## rpi-sb-provisioner 2.1.3

=== provisioner-service/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,41 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 include(FetchContent)
+
+# Add jsoncpp FIRST (before Drogon) so Drogon finds and uses this vendored version
+# instead of finding system libjsoncpp-dev
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared libraries" FORCE)
+set(BUILD_STATIC_LIBS ON CACHE BOOL "Build static libraries" FORCE)
+set(JSONCPP_WITH_TESTS OFF CACHE BOOL "Compile and run JsonCpp test executables" FORCE)
+set(JSONCPP_WITH_POST_BUILD_UNITTEST OFF CACHE BOOL "Automatically run unit-tests as a post build step" FORCE)
+set(JSONCPP_WITH_PKGCONFIG_SUPPORT OFF CACHE BOOL "Generate and install .pc files" FORCE)
+set(JSONCPP_WITH_CMAKE_PACKAGE OFF CACHE BOOL "Generate and install cmake package files" FORCE)
+
+FetchContent_Declare(jsoncpp
+ GIT_REPOSITORY https://github.com/open-source-parsers/jsoncpp.git
+ GIT_TAG        1.9.6
+ EXCLUDE_FROM_ALL  # Prevents installation in packages
+)
+
+FetchContent_GetProperties(jsoncpp)
+string(TOLOWER "jsoncpp" jsoncppName)
+if(NOT ${jsoncppName}_POPULATED)
+  FetchContent_Populate(jsoncpp)
+  add_subdirectory(${${jsoncppName}_SOURCE_DIR} ${${jsoncppName}_BINARY_DIR} EXCLUDE_FROM_ALL)
+endif()
+
+# Set JSONCPP_INCLUDE_DIRS and JSONCPP_LIBRARIES so Drogon's find_package(Jsoncpp) succeeds
+# These variables are what FindJsoncpp.cmake looks for, and must be set before Drogon configures
+set(JSONCPP_INCLUDE_DIRS "${${jsoncppName}_SOURCE_DIR}/include" CACHE PATH "jsoncpp include dir" FORCE)
+set(JSONCPP_LIBRARIES jsoncpp_static CACHE STRING "jsoncpp library" FORCE)
+
+# Unset jsoncpp configuration flags
+unset(BUILD_SHARED_LIBS)
+unset(BUILD_STATIC_LIBS)
+unset(JSONCPP_WITH_TESTS)
+unset(JSONCPP_WITH_POST_BUILD_UNITTEST)
+unset(JSONCPP_WITH_PKGCONFIG_SUPPORT)
+unset(JSONCPP_WITH_CMAKE_PACKAGE)
 
 # Prevent installation of Drogon dependencies by setting BUILD_* options before declaring the dependency
 set(BUILD_EXAMPLES OFF CACHE BOOL "Build Drogon examples" FORCE)
@@ -21,7 +56,7 @@
 
 FetchContent_Declare(drogon
  GIT_REPOSITORY https://github.com/drogonframework/drogon.git
- GIT_TAG        v1.9.10
+ GIT_TAG        v1.9.11
  EXCLUDE_FROM_ALL  # Prevents installation in packages
 )
 
@@ -95,7 +130,7 @@
 
 FetchContent_Declare(curl
  GIT_REPOSITORY https://github.com/curl/curl.git
- GIT_TAG        curl-8_13_0
+ GIT_TAG        curl-8_16_0
  PATCH_COMMAND patch -p1 < ${CMAKE_SOURCE_DIR}/cmake/curl/http-no-auth.patch
  UPDATE_DISCONNECTED 1
  EXCLUDE_FROM_ALL  # Prevents installation in packages
@@ -167,10 +202,27 @@
 # Create a custom target for downloading ZXing
 add_custom_target(download_zxing DEPENDS ${ZXING_JS_PATH})
 
+# Download D3.js library for graph visualization
+set(D3_JS_URL "https://cdn.jsdelivr.net/npm/d3@7.9.0/dist/d3.min.js")
+set(D3_JS_PATH "${CMAKE_SOURCE_DIR}/static/js/d3.min.js")
+
+# Add a custom command to download D3.js at build time
+add_custom_command(
+    OUTPUT ${D3_JS_PATH}
+    COMMAND ${CMAKE_COMMAND} -E echo "Downloading D3.js library from ${D3_JS_URL}"
+    COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_SOURCE_DIR}/static/js"
+    COMMAND curl --silent --show-error --output ${D3_JS_PATH} ${D3_JS_URL}
+    COMMAND ${CMAKE_COMMAND} -E echo "D3.js library downloaded to ${D3_JS_PATH}"
+    COMMENT "Downloading D3.js visualization library"
+    VERBATIM
+)
+
+# Create a custom target for downloading D3.js
+add_custom_target(download_d3 DEPENDS ${D3_JS_PATH})
+
 project(rpi-provisioner-ui)
 
 find_package(SQLite3 REQUIRED)
-find_package(jsoncpp REQUIRED)
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(systemd REQUIRED libsystemd)
 find_package(OpenSSL REQUIRED)
@@ -210,6 +262,9 @@
 # Add zxing dependency
 add_dependencies(rpi-provisioner-ui download_zxing)
 
+# Add D3.js dependency
+add_dependencies(rpi-provisioner-ui download_d3)
+
 target_sources(rpi-provisioner-ui
     PRIVATE
     src/main.cpp
@@ -235,23 +290,6 @@
 
 target_link_libraries(rpi-provisioner-ui
     PRIVATE
-    ${jsoncpp_LIBRARY}
+    jsoncpp_static
     drogon
     ${systemd_LIBRARIES}
-    ${SQLite3_LIBRARY}
-    libcurl
-    OpenSSL::SSL
-    OpenSSL::Crypto
-)
-
-# Install directives
-# Only install our executable and service file, not any of the FetchContent dependencies
-install(TARGETS rpi-provisioner-ui
-    RUNTIME DESTINATION /usr/bin
-)
-
-# Install static files
-install(DIRECTORY "${CMAKE_SOURCE_DIR}/static/"
-        DESTINATION /usr/share/rpi-sb-provisioner/static
-        FILES_MATCHING PATTERN "*.js"
-        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)
