=== debian/control ===
Source: rpi-sb-provisioner
Section: admin
Priority: optional
Maintainer: Tom Dewey <tom.dewey@raspberrypi.com>
Build-Depends: debhelper-compat (= 13), cmake (>= 3.25), g++ (>= 10), libsqlite3-dev, libsystemd-dev, pandoc, asciidoctor, uuid-dev, libssl-dev
Standards-Version: 4.7.2
Homepage: https://www.raspberrypi.com/software

Package: rpi-sb-provisioner
Architecture: arm64
Pre-Depends: dpkg (>= 1.16.1), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, fastboot (>= 33.0.3), python3, python3-pycryptodome, openssl, cpio, android-sdk-platform-tools, rpi-eeprom (>= 28.8-1), rpiboot (>= 20251107~092017), curl, dctrl-tools, diffutils, libengine-pkcs11-openssl, libp11-kit-dev, gnutls-bin, jq, sqlite3, iputils-ping, rpi-make-boot-image, android-sdk-libsparse-utils, libsystemd0, xxd
Description: Automated provisioning of secure boot for Raspberry Pi Devices
 This package provides tools for configuring and provisioning Raspberry Pi
 devices with secure boot capabilities. It enables automated setup of
 security features including secure boot chains, firmware verification,
 and hardware-backed security mechanisms on supported Raspberry Pi models.
